

%%%%%%%%%%%%%% The following matlab code for ANN Forecasting %%%%%%%%%%%%%%%%%%%%%
% The ANN was run in three configurations, i.e, two hidden layers with
% 10, 20, and 30 neurons in each layer. Two hidden layers with 20 
% neurons were chosen as a the comparison model, because they 
% afforded better results than the other two configurations.

% M. H. Beale, M. T. Hagan, H. B. Demuth, Neural network toolbox users
% guide, The MathWorks (2010) 7781.

%Statistics and Machine Learning Toolbox User's Guide
%COPYRIGHT 19932021 by The MathWorks, Inc.

% Signal Processing Toolbox User's Guide
% COPYRIGHT 19882020 by The MathWorks, Inc

%---------------------------------------------FREQUENCY-------------------------------------
close all; 
rng(1);
clear net; 
net = fitnet([20 20]);
net.trainParam.epochs = 100;
%net.trainParam.min_grad = 1e-06;
%net.trainParam.max_fail=100;
net.trainParam.goal=0; 

 net = train(net,  Train_inputs', Fr_train');
 
 NN_RESULT = net(Test_inputs')';
 


%frequency_NN_RMSE = sqrt( mean(Fr_test - NN_RESULT).^2 );  % RMSE
frequency_NN_RMSE = sqrt(mean((Fr_test - NN_RESULT).^2));  % RMSE  or RMSD  
frequency_NN_MAPE = mean(abs((Fr_test - NN_RESULT)./Fr_test))*100;
frequency_NN_RMSE
frequency_NN_MAPE

%------------------------------VOLTAGE------------------------------------------------------------------------
clear net; clear NN_RESULT; 
rng(1);
net = fitnet([20 20]);
net.trainParam.epochs = 100;
%net.trainParam.min_grad = 1e-06;
%net.trainParam.max_fail=100;
net.trainParam.goal=0; 

 net = train(net,  Train_inputs', volt_train');
 
 NN_RESULT = net(Test_inputs')';


%Voltage_NN_RMSE = sqrt( mean(volt_test - NN_RESULT).^2 );  % RMSE  
Voltage_NN_RMSE = sqrt(mean((volt_test - NN_RESULT).^2));  % RMSE  or RMSD
Voltage_NN_MAPE = mean(abs((volt_test - NN_RESULT)./volt_test))*100;
Voltage_NN_RMSE
Voltage_NN_MAPE


%--------------------------------------THDU----------------------------------------------

clear net; clear NN_RESULT; 
rng(1);

net = fitnet([20 20]);
net.trainParam.epochs = 100;
net.trainParam.min_grad = 1e-06;
%net.trainParam.max_fail=100;
net.trainParam.goal=0; 

 net = train(net,  Train_inputs', thdu_train');
 
 
 NN_RESULT = net(Test_inputs')';

%THDU_NN_RMSE = sqrt( mean(thdu_test - NN_RESULT).^2 );  % RMSE
THDU_NN_RMSE = sqrt(mean((thdu_test - NN_RESULT).^2));  % RMSE  or RMSD
THDU_NN_MAPE = mean(abs((thdu_test - NN_RESULT)./thdu_test))*100;
THDU_NN_RMSE
THDU_NN_MAPE


%-------------------------------------------------THDI---------------------------------------------------
clear net; clear NN_RESULT; 
rng(1);
net = fitnet([20 20]);

net.trainParam.epochs = 100;
net.trainParam.min_grad = 1e-06;
%net.trainParam.max_fail=100;
net.trainParam.goal=0; 

 net = train(net,  Train_inputs', thdi_train');

 NN_RESULT = net(Test_inputs')';

THDI_NN_RMSE = sqrt(mean((thdi_test - NN_RESULT).^2));  % RMSE  or RMSD
THDI_NN_MAPE = mean(abs((thdi_test - NN_RESULT)./thdi_test))*100;
THDI_NN_RMSE
THDI_NN_MAPE

 