


%%%%%%%%%%%%%% The following matlab code for Bagging and Boosting DT %%%%%%%%%%%%%%%%%%%%%
% In the following matlab code for two decision tree models have been used:
% bagging and boosting decision tree

%https://www.mathworks.com/help/stats/fitrensemble.html#d123e416031

% M. H. Beale, M. T. Hagan, H. B. Demuth, Neural network toolbox users
% guide, The MathWorks (2010) 7781.

%Statistics and Machine Learning Toolbox User's Guide
%COPYRIGHT 19932021 by The MathWorks, Inc.

% Signal Processing Toolbox User's Guide
%  COPYRIGHT 19882020 by The MathWorks, Inc

%------------------------------FREQUENCY-----------------
close all; clear DT; clear DT_RESULT; 

%DT = fitrensemble(Train_inputs, Fr_train, 'Method','bag'); 
DT = fitrensemble(Train_inputs, Fr_train, 'Method','LSBoost');

 DT_RESULT = predict(DT,Test_inputs);
  
frequency_DT_RMSE = sqrt(mean((Fr_test - DT_RESULT).^2));  % RMSE  or RMSD
frequency_DT_MAPE = mean(abs((Fr_test - DT_RESULT)./Fr_test))*100;
frequency_DT_RMSE
frequency_DT_MAPE

%------------------------------VOLTAGE------------------------------------------------------------------------

clear DT; clear DT_RESULT; 
%DT = fitrensemble(Train_inputs, volt_train, 'Method','bag'); 
DT = fitrensemble(Train_inputs, volt_train, 'Method','LSBoost');


DT_RESULT = predict(DT,Test_inputs);

 figure (2);
 t0 = datetime(2021,8,16);
 t= 1:16;
 t = t0 + hours(t);
 %yyaxis left
 plot(t,volt_test,'DatetimeTickFormat','HH:mm:ss','color','r'); title('Actual and forecasted Voltage using Boosting DT'); hold on;
plot(t,DT_RESULT,'DatetimeTickFormat','HH:mm:ss','color','b');
% legend('Actual Voltage','Forecasting Voltage','Location','northwest');
 xlabel(' Time'); % x-axis label
%ylabel({'y normalized Load';'Power Load (W) = y x 3.333 x 10^3'}); % y-axis label
ylabel('Power Voltage (V)'); % y-axis label
%yyaxis right;
%plot(t,test_power, 'DatetimeTickFormat','HH:mm:ss','color','g');
%ylabel('Power (Kw)');
legend('Actual Voltage','Forecasted Voltage', 'Location','northwest');


%Voltage_DT_RMSE = sqrt( mean(volt_test - DT_RESULT).^2 );  % RMSE
Voltage_DT_RMSE = sqrt(mean((volt_test - DT_RESULT).^2));  % RMSE  or RMSD
Voltage_DT_MAPE = mean(abs((volt_test - DT_RESULT)./volt_test))*100;
Voltage_DT_RMSE
Voltage_DT_MAPE


%--------------------------------------THDU----------------------------------------------
clear DT; clear DT_RESULT; 

%DT = fitrensemble(Train_inputs, thdu_train, 'Method','bag'); 
DT = fitrensemble(Train_inputs, thdu_train, 'Method','LSBoost');



 DT_RESULT = predict(DT,Test_inputs);

 figure (3);
 t0 = datetime(2021,8,17);
 t= 1:16;
 t = t0 + hours(t);
 %yyaxis left
 plot(t,thdu_test,'DatetimeTickFormat','HH:mm:ss','color','r'); title('Actual and forecasted THD_{u} using Bossting DT'); hold on;
plot(t,DT_RESULT,'DatetimeTickFormat','HH:mm:ss','color','b');
% legend('Actual Voltage','Forecasting Voltage','Location','northwest');
 xlabel(' Time'); % x-axis label
%ylabel({'y normalized Load';'Power Load (W) = y x 3.333 x 10^3'}); % y-axis label
ylabel('THD_{u} (%)'); % y-axis label
%yyaxis right;
%plot(t,test_power, 'DatetimeTickFormat','HH:mm:ss','color','g');
%ylabel('Power (Kw)');
legend('Actual THD_{u}','Forecasted THD_{u}', 'Location','northwest');

%THDU_DT_RMSE = sqrt( mean(thdu_test - DT_RESULT).^2 );  % RMSE
THDU_DT_RMSE = sqrt(mean((thdu_test - DT_RESULT).^2));  % RMSE  or RMSD
THDU_DT_MAPE = mean(abs((thdu_test - DT_RESULT)./thdu_test))*100;
THDU_DT_RMSE
THDU_DT_MAPE

%-------------------------------------------------THDI---------------------------------------------------
clear DT; clear DT_RESULT; 

%DT = fitrensemble(Train_inputs,thdi_train, 'Method','bag'); %dt
DT = fitrensemble(Train_inputs,thdi_train, 'Method','LSBoost');




 DT_RESULT = predict(DT,Test_inputs);
 
 figure (4);
 t0 = datetime(2021,8,17);
 t= 1:16;
 t = t0 + hours(t);
 %yyaxis left
 plot(t,thdi_test,'DatetimeTickFormat','HH:mm:ss','color','r'); title('Actual and forecasted THD_{i} using Boosting DT'); hold on;
plot(t,DT_RESULT,'DatetimeTickFormat','HH:mm:ss','color','b');
% legend('Actual Voltage','Forecasting Voltage','Location','northwest');
 xlabel(' Time'); % x-axis label
%ylabel({'y normalized Load';'Power Load (W) = y x 3.333 x 10^3'}); % y-axis label
ylabel('THD_{i} (%)'); % y-axis label
%yyaxis right;
%plot(t,test_power, 'DatetimeTickFormat','HH:mm:ss','color','g');
%ylabel('Power (Kw)');
legend('Actual THD_{i}','Forecasted THD_{i}', 'Location','northwest');

%THDI_DT_RMSE = sqrt( mean(thdi_test - DT_RESULT).^2 );  % RMSE
THDI_DT_RMSE = sqrt(mean((thdi_test - DT_RESULT).^2));  % RMSE  or RMSD
THDI_DT_MAPE = mean(abs((thdi_test - DT_RESULT)./thdi_test))*100;
THDI_DT_RMSE
THDI_DT_MAPE





