
%%%%%%%%%%%%%%%%%%%%%% LR Interactions %%%%%%%%%%%%%%%%%%%%%%

% Model contains an intercept, linear term for each predictor, 
% and all products of pairs of distinct predictors (no squared terms).

%https://www.mathworks.com/help/stats/fitlm.html

% M. H. Beale, M. T. Hagan, H. B. Demuth, Neural network toolbox users
% guide, The MathWorks (2010) 7781.

%Statistics and Machine Learning Toolbox User's Guide
%COPYRIGHT 19932021 by The MathWorks, Inc.

% Signal Processing Toolbox User's Guide
%  COPYRIGHT 19882020 by The MathWorks, Inc


%---------------------------------------------FREQUENCY-------------------------------------------------
close all;
clear ILR; clear ILR_RESULT; 

ILR = fitlm(Train_inputs, Fr_train, 'interactions');   %ILR 
ILR_RESULT = predict(ILR,Train_inputs);

 ILR_RESULT = predict(ILR,Test_inputs);
 
 


%frequency_LR_RMSE = sqrt( mean(Fr_test - ILR_RESULT).^2 );   
frequency_RMSE = sqrt(mean((Fr_test - ILR_RESULT).^2));  % RMSE  or RMSD
frequency_LR_MAPE = mean(abs((Fr_test - ILR_RESULT)./Fr_test))*100;
frequency_RMSE
frequency_LR_MAPE


%------------------------------VOLTAGE------------------------------------------------------------------------
clear ILR; clear ILR_RESULT; 
ILR = fitlm(Train_inputs, volt_train, 'interactions'); %LR


 ILR_RESULT = predict(ILR,Test_inputs);
 
 

Voltage_ILR_RMSE = sqrt(mean((volt_test - ILR_RESULT).^2));  % RMSE  or RMSD
Voltage_ILR_MAPE = mean(abs((volt_test - ILR_RESULT)./volt_test))*100;
Voltage_ILR_RMSE
Voltage_ILR_MAPE


%--------------------------------------THDU----------------------------------------------

clear ILR; clear ILR_RESULT; 

ILR = fitlm(Train_inputs, thdu_train, 'interactions'); %LR

ILR_RESULT = predict(ILR,Test_inputs);

   
THDU_ILR_RMSE = sqrt(mean((thdu_test - ILR_RESULT).^2));  % RMSE  or RMSD
THDU_ILR_MAPE = mean(abs((thdu_test - ILR_RESULT)./thdu_test))*100;
THDU_ILR_RMSE
THDU_ILR_MAPE


%-------------------------------------------------THDI---------------------------------------------------
clear ILR; clear ILR_RESULT; 
ILR = fitlm(Train_inputs, thdi_train, 'interactions'); %LR

ILR_RESULT = predict(ILR,Test_inputs);
 
 
THDI_ILR_RMSE = sqrt(mean((thdi_test - ILR_RESULT).^2));  % RMSE  or RMSD
THDI_ILR_MAPE = mean(abs((thdi_test - ILR_RESULT)./thdi_test))*100;
THDI_ILR_RMSE
THDI_ILR_MAPE



