
%%%%%%%%%%%%%%%%%%%%%% Linear Regression %%%%%%%%%%%%%%%%%%%
%Model contains an intercept and linear term for each predictor

%https://www.mathworks.com/help/stats/fitlm.html

% M. H. Beale, M. T. Hagan, H. B. Demuth, Neural network toolbox users
% guide, The MathWorks (2010) 7781.

%Statistics and Machine Learning Toolbox User's Guide
%COPYRIGHT 19932021 by The MathWorks, Inc.

% Signal Processing Toolbox User's Guide
%  COPYRIGHT 19882020 by The MathWorks, Inc

%---------------------------------------------FREQUENCY-------------------------------------------------
close all;
clear LR; clear LR_RESULT; 

LR = fitlm(Train_inputs, Fr_train, 'linear');   


 LR_RESULT = predict(LR,Test_inputs);
 
 
frequency_LR_RMSE = sqrt(mean((Fr_test - LR_RESULT).^2));  % RMSE  or RMSD
frequency_LR_MAPE = mean(abs((Fr_test - LR_RESULT)./Fr_test))*100;
frequency_LR_RMSE
frequency_LR_MAPE

%------------------------------VOLTAGE------------------------------------------------------------------------
clear LR; clear LR_RESULT;

LR = fitlm(Train_inputs, volt_train, 'linear'); %LR


LR_RESULT = predict(LR,Test_inputs);
 

Voltage_LR_RMSE = sqrt(mean((volt_test - LR_RESULT).^2));  % RMSE  or RMSD
Voltage_LR_MAPE = mean(abs((volt_test - LR_RESULT)./volt_test))*100;
Voltage_LR_RMSE
Voltage_LR_MAPE


%--------------------------------------THDU----------------------------------------------
clear LR; clear LR_RESULT;

LR = fitlm(Train_inputs, thdu_train, 'linear'); %LR
LR_RESULT = predict(LR,Test_inputs);

 
%THDU_LR_RMSE = sqrt( mean(thdu_test - LR_RESULT).^2 );  % RMSE 
THDU_LR_RMSE = sqrt(mean((thdu_test - LR_RESULT).^2));  % RMSE  or RMSD
THDU_LR_MAPE = mean(abs((thdu_test - LR_RESULT)./thdu_test))*100;
THDU_LR_RMSE
THDU_LR_MAPE


%-------------------------------------------------THDI---------------------------------------------------
clear LR; clear LR_RESULT; 

LR = fitlm(Train_inputs, thdi_train, 'linear'); %L
LR_RESULT = predict(LR,Test_inputs);

  
THDI_LR_RMSE = sqrt(mean((thdi_test - LR_RESULT).^2));  % RMSE  or RMSD
THDI_LR_MAPE = mean(abs((thdi_test - LR_RESULT)./thdi_test))*100;
THDI_LR_RMSE
THDI_LR_MAPE




