
%%%%%%%%%%%%%%%% This matlab code for LR quadratic%%%%%%%%%%%%%%%%%%%%%%
% Model contains an intercept term, linear and squared terms for each predictor,
% and all products of pairs of distinct predictors.

%https://www.mathworks.com/help/stats/fitlm.html

% M. H. Beale, M. T. Hagan, H. B. Demuth, Neural network toolbox users
% guide, The MathWorks (2010) 7781.

% Statistics and Machine Learning Toolbox User's Guide
%  COPYRIGHT 19932021 by The MathWorks, Inc.

% Signal Processing Toolbox User's Guide
%  COPYRIGHT 19882020 by The MathWorks, Inc.

%---------------------------------------------FREQUENCY-------------------------------------------------
close all;
clear QLR ; clear QLR_RESULT; 

QLR = fitlm(Train_inputs, Fr_train, 'quadratic');   


 QLR_RESULT = predict(QLR,Test_inputs);


%frequency_LR_RMSE = sqrt( mean(Fr_test -  QLR_RESULT).^2 );  % RMSE
frequency_QLR_RMSE = sqrt(mean((Fr_test - QLR_RESULT).^2));  % RMSE  or RMSD
frequency_QLR_MAPE = mean(abs((Fr_test -  QLR_RESULT)./Fr_test))*100;
frequency_QLR_RMSE
frequency_QLR_MAPE

%------------------------------VOLTAGE------------------------------------------------------------------------
clear QLR ; clear QLR_RESULT; 

QLR = fitlm(Train_inputs, volt_train, 'quadratic'); %LR


 QLR_RESULT = predict(QLR,Test_inputs);


%Voltage_LR_RMSE = sqrt( mean(volt_test - QLR_RESULT).^2 );  % RMSE
Voltage_QLR_RMSE = sqrt(mean((volt_test - QLR_RESULT).^2));  % RMSE  or RMSD
Voltage_QLR_MAPE = mean(abs((volt_test - QLR_RESULT)./volt_test))*100;
Voltage_QLR_RMSE
Voltage_QLR_MAPE


%--------------------------------------THDU----------------------------------------------

clear QLR ; clear QLR_RESULT; 

QLR = fitlm(Train_inputs, thdu_train, 'quadratic'); %LR


QLR_RESULT = predict(QLR,Test_inputs);


THDU_QLR_RMSE = sqrt(mean((thdu_test - QLR_RESULT).^2));  % RMSE  or RMSD
THDU_QLR_MAPE = mean(abs((thdu_test - QLR_RESULT)./thdu_test))*100;
THDU_QLR_RMSE
THDU_QLR_MAPE


%-------------------------------------------------THDI---------------------------------------------------
clear QLR ; clear QLR_RESULT; 

QLR = fitlm(Train_inputs, thdi_train, 'quadratic'); %LR
 
QLR_RESULT = predict(QLR,Test_inputs);
 

THDI_QLR_RMSE = sqrt(mean((thdi_test - QLR_RESULT).^2));  % RMSE  or RMSD
THDI_QLR_MAPE = mean(abs((thdi_test - QLR_RESULT)./thdi_test))*100;
THDI_QLR_RMSE
THDI_QLR_MAPE


 
 





 
 



