

%%%%%%%%%%%%%% The following matlab code for preparation training data set %%%%%%%%%%%%%%%%%%%%%
% The input variables are solar irradiance (SI), wind speed (WS), air pressure (PR),
% air temperature (TEM), and power load (PL). The output are Frequency, voltage, THDu, and THDi


clc; clear all; close all; 
weather_data = xlsread('data\august_weather.xlsx');  %reading weather data

power_data = xlsread('data\august_power.xlsx');   %reading power data

power_data=power_data(1:10:end, :);
Freq= power_data (:, 11); 
Voltage= power_data (:, 1);
THDu= power_data (:, 12);
THDi= power_data (:, 13);
Flick= power_data (:, 8);
Load= power_data (:, 3);
Plt= power_data (:, 9);

%all_data = [weather_data Load Freq Voltage THDu THDi Flick ]; 
all_data = [weather_data Load Freq Voltage THDu THDi Flick Plt]; 

off1= all_data(1:99, :); 
off2= all_data(137:243, :); 
off3= all_data(281:387, :);
off4= all_data(425:531, :);
off5= all_data(569:675, :);
off6= all_data(713:819, :);
off7= all_data(857:963, :);
off8= all_data(1001:1107, :);
off9= all_data(1145:1251, :);

off10= all_data(1289:1395, :);
off11= all_data(1433:1539, :);
off12= all_data(1577:1683, :);

off13= all_data(1721:1827, :);
off14= all_data(1865:1971, :);
off15= all_data(2009:2115, :);
off16= all_data(2153:2259, :);
off17= all_data(2297:2403, :);
off18= all_data(2441:2547, :);
off19= all_data(2585:2691, :);
off20= all_data(2729:2835, :);
off21= all_data(2873:2979, :);
off22= all_data(3017:3123, :);
off23= all_data(3161:3267, :);
off24= all_data(3305:3411, :);
off25= all_data(3449:3555, :);
off26= all_data(3593:3699, :);
off27= all_data(3737:3843, :);
off28= all_data(3881:3987, :);
off29= all_data(4025:4131, :);
off30= all_data(4169:4275, :);
off31= all_data(4313:4419, :);
off32= all_data(4457:4464, :);

Train_data= [off1; off2; off3; off4; off5; off6; off7; off8; off9; off10; off11; off12; off13; off14; off15];
Train_inputs = Train_data(:, 1:5); 
Train_Target= Train_data(:, 6:10); 
Fr_train=Train_Target(:,1);
volt_train=Train_Target(:,2);
thdu_train=Train_Target(:,3);
thdi_train=Train_Target(:,4);
%flicker_train=Train_Target(:,5);


%%%%%%%%%%%%%% The following matlab code for preparation testing data set %%%%%%%%%%%%%%%%%%%%%
%%%% should selecting one day from following testing days
%-----------------------------
%16th of August 2021
%off16_1_14h= off16(15:105, :); %selecting samples from 1:00 till 16:00 clock
%off16_1_14h_one_houre=off16_1_14h(1:6:end, :); %selecting the samples every one hour 
%off00_1_14h_one_houre = off16_1_14h_one_houre; 

%---------------------------------------------------------
%17th of August 2021
off17_1_14h= off17(15:105, :); %selecting samples from 1:00 till 16:00 clock  20th good 21,24,  
off17_1_14h_one_houre=off17_1_14h(1:6:end, :);  %selecting the samples every one hour
off00_1_14h_one_houre = off17_1_14h_one_houre;
%---------------------------------------------------
%18th of August 2021
%off18_1_14h= off18(15:105, :); %selecting samples from 1:00 till 16:00 clock  20th good 21,24,  
%off18_1_14h_one_houre=off18_1_14h(1:6:end, :);  %selecting the samples every one hour
%off00_1_14h_one_houre = off18_1_14h_one_houre;
%-------------------------------------

Testing_data=off00_1_14h_one_houre; 
Test_inputs = Testing_data(:, 1:5); 
Test_output= Testing_data(:, 6:10);
Fr_test=Test_output(:,1);
volt_test=Test_output(:,2);
thdu_test=Test_output(:,3);
thdi_test=Test_output(:,4);
flicker_test=Test_output(:,5);

